unit U_spiel;

interface

const Steinwert: array[1..2] of byte = (1,5);
      Spieler1 = 1;
      Spieler2 = 2;

      { Strategieparameter }
(*
      Parameter_a:longint = 1;     { Gegnerische Einerreihe }
      Parameter_b:longint = 5;     { eigene Einerreihe }
      Parameter_c:longint = 30;    { Gegnerische 2erreihe }
      Parameter_d:longint = 150;   { eigene 2erreihe }
      Parameter_e:longint = 1800;   { Gegnerische 3erreihe }
      Parameter_f:longint = 15000;  { eigene 3erreihe }
      Parameter_g:longint = 150000; { Gegnerische 4erreihe }
      Parameter_h:longint = 1500000; { eigene 4erreihe }
*)
      Parameter_a:longint = 1;     { Gegnerische Einerreihe }
      Parameter_b:longint = 2;     { eigene Einerreihe }
      Parameter_c:longint = 50;    { Gegnerische 2erreihe }
      Parameter_d:longint = 150;   { eigene 2erreihe }
      Parameter_e:longint = 500;   { Gegnerische 3erreihe }
      Parameter_f:longint = 1000;  { eigene 3erreihe }
      Parameter_g:longint = 50000; { Gegnerische 4erreihe }
      Parameter_h:longint = 100000; { eigene 4erreihe }

type
  TSteinwert = byte;
  TSpieler = Spieler1..Spieler2;
  TSpielertyp = (Keiner, Mensch, Computer);
  TReihensummenHaeufigkeit = array[0..20] of integer;
  TSiegreihe = array[0..3] of record x,y,z: 0..3; end;
  TZug= record
          x,y: integer;
        end;
  TSpielfeld = array[0..3,0..3,0..3] of TSteinwert;
  TPosition = record
                Feld: TSpielfeld;
                amZug: TSpieler;
              end;
  TSpiel = class
    Position: TPosition;
    Spielertyp: array[1..2] of TSpielertyp;
    MaxSuchtiefe: integer;
    Siegreihe: TSiegreihe;
    constructor create(sp1, sp2: TSpielertyp; MaxSuchtiefe: integer);
    function ReihensummenHaeufigkeit(Pos: TPosition): TReihensummenHaeufigkeit;
    function zulaessig(Pos: TPosition; Zug: TZug): boolean;
    function amEnde(Pos: TPosition): boolean;
    function ZKoordinateVonZug(Pos: TPosition; Zug: TZug): integer;
    procedure Ausfuehren(Pos: TPosition; Zug: TZug; var neuPos: TPosition);
    function Computerzug(var Wertung: longint): TZug;
  function HeuristischerWert(Pos: TPosition): longint;
  function negmax(tiefe: integer; Pos: TPosition; var BesterZug: TZug): longint;

  end;


implementation

constructor TSpiel.Create(sp1, sp2: TSpielertyp; MaxSuchtiefe: integer);
var x,y,z: integer;
begin
  inherited create;
  for x:= 0 to 3
  do for y:= 0 to 3
     do for z:= 0 to 3
        do Position.Feld[x,y,z]:= 0;
  Position.amZug:= Spieler1;
  Spielertyp[1]:= sp1;
  Spielertyp[2]:= sp2;
  Self.MaxSuchtiefe:= MaxSuchtiefe;
end;

function TSpiel.ReihensummenHaeufigkeit(Pos: TPosition): TReihensummenHaeufigkeit;
var summe: integer;
    x,y,z: integer;
    Haeufigkeiten: TReihensummenHaeufigkeit;
begin
  for x:= 0 to 20 do Haeufigkeiten[x]:= 0;
  { Durchsuche alle Stbe nach oben }
  for x:= 0 to 3
    do begin
         for y:= 0 to 3
           do begin
                summe:= 0;
                for z:= 0 to 3
                  do summe:= summe+pos.Feld[x,y,z];
                inc(Haeufigkeiten[summe]);
                if summe in [4,20]
                 then for z:= 0 to 3 do begin Siegreihe[z].x:= x; Siegreihe[z].y:= y; Siegreihe[z].z:= z; end;
              end;
       end;
  { Durchsuche alle Reihen von links nach rechts }
  for y:= 0 to 3
    do begin
         for z:= 0 to 3
           do begin
                summe:= 0;
                for x:= 0 to 3
                  do summe:= summe+pos.Feld[x,y,z];
                inc(Haeufigkeiten[summe]);
                if summe in [4,20]
                 then for x:= 0 to 3 do begin Siegreihe[x].x:= x; Siegreihe[x].y:= y; Siegreihe[x].z:= z; end;
              end;
       end;
  { Durchsuche alle Reihen von hinten nach vorne }
  for x:= 0 to 3
    do begin
         for z:= 0 to 3
           do begin
                summe:= 0;
                for y:= 0 to 3
                  do summe:= summe+pos.Feld[x,y,z];
                inc(Haeufigkeiten[summe]);
                if summe in [4,20]
                 then for y:= 0 to 3 do begin Siegreihe[y].x:= x; Siegreihe[y].y:= y; Siegreihe[y].z:= z; end;
              end;
       end;
  { Durchsuche alle Diaognalen von unten hinten nach oben vorne }
  for x:= 0 to 3
    do begin
         summe:= 0;
         for y:= 0 to 3
           do summe:= summe+pos.Feld[x,y,y];
         inc(Haeufigkeiten[summe]);
         if summe in [4,20]
          then for y:= 0 to 3 do begin Siegreihe[y].x:= x; Siegreihe[y].y:= y; Siegreihe[y].z:= y; end;
       end;
  { Durchsuche alle Diaognalen von oben hinten nach unten vorne }
  for x:= 0 to 3
    do begin
         summe:= 0;
         for y:= 0 to 3
           do summe:= summe+pos.Feld[x,y,3-y];
         inc(Haeufigkeiten[summe]);
         if summe in [4,20]
          then for y:= 0 to 3 do begin Siegreihe[y].x:= x; Siegreihe[y].y:= y; Siegreihe[y].z:= 3-y; end;
       end;
  { Durchsuche alle Diaognalen von unten links nach oben rechts }
  for y:= 0 to 3
    do begin
         summe:= 0;
         for x:= 0 to 3
           do summe:= summe+pos.Feld[x,y,x];
         inc(Haeufigkeiten[summe]);
         if summe in [4,20]
          then for x:= 0 to 3 do begin Siegreihe[x].x:= x; Siegreihe[x].y:= y; Siegreihe[x].z:= x; end;
       end;
  { Durchsuche alle Diaognalen von oben links nach unten rechts }
  for y:= 0 to 3
    do begin
         summe:= 0;
         for x:= 0 to 3
           do summe:= summe+pos.Feld[x,y,3-x];
         inc(Haeufigkeiten[summe]);
         if summe in [4,20]
          then for x:= 0 to 3 do begin Siegreihe[x].x:= x; Siegreihe[x].y:= y; Siegreihe[x].z:= 3-x; end;
       end;
  { Durchsuche alle Diaognalen von hinten links nach vorne rechts }
  for z:= 0 to 3
    do begin
         summe:= 0;
         for x:= 0 to 3
           do summe:= summe+pos.Feld[x,x,z];
         inc(Haeufigkeiten[summe]);
         if summe in [4,20]
          then for x:= 0 to 3 do begin Siegreihe[x].x:= x; Siegreihe[x].y:= x; Siegreihe[x].z:= z; end;
       end;
  { Durchsuche alle Diaognalen von vorne links nach hinten rechts }
  for z:= 0 to 3
    do begin
         summe:= 0;
         for x:= 0 to 3
           do summe:= summe+pos.Feld[x,3-x,z];
         inc(Haeufigkeiten[summe]);
         if summe in [4,20]
          then for x:= 0 to 3 do begin Siegreihe[x].x:= x; Siegreihe[x].y:= 3-x; Siegreihe[x].z:= z; end;
       end;
  { Durchsuche Diaognale von vorne links unten nach hinten rechts oben }
  summe:= 0;
  for x:= 0 to 3
    do summe:= summe+pos.Feld[x,x,x];
  inc(Haeufigkeiten[summe]);
  if summe in [4,20]
   then for x:= 0 to 3 do begin Siegreihe[x].x:= x; Siegreihe[x].y:= x; Siegreihe[x].z:= x; end;
  { Durchsuche Diaognale von vorne links oben nach hinten rechts unten }
  summe:= 0;
  for x:= 0 to 3
    do summe:= summe+pos.Feld[x,x,3-x];
  inc(Haeufigkeiten[summe]);
  if summe in [4,20]
   then for x:= 0 to 3 do begin Siegreihe[x].x:= x; Siegreihe[x].y:= x; Siegreihe[x].z:= 3-x; end;
  { Durchsuche Diaognale von hinten links unten nach vorne rechts oben }
  summe:= 0;
  for x:= 0 to 3
    do summe:= summe+pos.Feld[x,3-x,x];
  inc(Haeufigkeiten[summe]);
  if summe in [4,20]
   then for x:= 0 to 3 do begin Siegreihe[x].x:= x; Siegreihe[x].y:= 3-x; Siegreihe[x].z:= x; end;
  { Durchsuche Diaognale von hinten links oben nach vorne rechts unten }
  summe:= 0;
  for x:= 0 to 3
    do summe:= summe+pos.Feld[x,3-x,3-x];
  inc(Haeufigkeiten[summe]);
  if summe in [4,20]
   then for x:= 0 to 3 do begin Siegreihe[x].x:= x; Siegreihe[x].y:= 3-x; Siegreihe[x].z:= 3-x; end;

  Reihensummenhaeufigkeit:= Haeufigkeiten;
end;

function TSpiel.zulaessig(Pos: TPosition; Zug: TZug): boolean;
var z: integer;
begin
  z:= 0;
  while (Pos.Feld[Zug.x,Zug.y,z]<>0) and (z<3)
    do inc(z);
  if Pos.Feld[Zug.x,Zug.y,z]<>0
  then zulaessig:= false
  else zulaessig:= true;
end;

function TSpiel.ZKoordinateVonZug(Pos: TPosition; Zug: TZug): integer;
var z: integer;
begin
  z:= 0;
  while (Pos.Feld[Zug.x,Zug.y,z]<>0) and (z<3)
  do inc(z);
  ZKoordinateVonZug:= z;
end;

procedure TSpiel.Ausfuehren(Pos: TPosition; Zug: TZug; var neuPos: TPosition);
var x,y,z: integer;
begin
  for x:= 0 to 3 do for y:= 0 to 3 do for z:= 0 to 3 do neuPos.Feld[x,y,z]:= Pos.Feld[x,y,z];
  z:= ZKoordinatevonZug(neuPos,Zug);
  neuPos.Feld[Zug.x,Zug.y,z]:= Steinwert[Pos.amZug];
  if Pos.amZug=Spieler1
    then neuPos.amZug:= Spieler2
    else neuPos.amZug:= Spieler1;
end;

function TSpiel.amEnde(Pos: TPosition): boolean;
var ende: boolean;
    x,y,z: integer;
    h: TReihensummenHaeufigkeit;
begin
  h:= ReihensummenHaeufigkeit(Pos);
  ende:= (h[4]>0) or (h[20]>0);
  if not ende
  then begin
         ende:= true;
         for x:= 0 to 3 do for y:= 0 to 3 do for z:= 0 to 3 do if Pos.Feld[x,y,z]=0 then ende:= false;
       end;
   amEnde:= ende;
end;

  function TSpiel.HeuristischerWert(Pos: TPosition): longint;
  var h: TReihensummenHaeufigkeit;
      c: integer;
  begin
    h:= ReihensummenHaeufigkeit(Pos);
    c:= Steinwert[Pos.amZug];
    HeuristischerWert:=
                  -Parameter_a*h[1*(6-c)]             { gegnerische Einerreihen }
                  +Parameter_b*h[1*c]                 { eigne Einerreihen }
                  -Parameter_c*h[2*(6-c)]             { gegnerische Zweierreihen }
                  +Parameter_d*h[2*c]                 { eigne Zweierreihen }
                  -Parameter_e*h[3*(6-c)]             { gegnerische Dreierreihen }
                  +Parameter_f*h[3*c]                 { eigne Dreierreihen }
                  -Parameter_g*h[4*(6-c)]             { gegnerische Viererreihen }
                  +Parameter_h*h[4*c]                 { eigene Viererreihen }
  end;

  function TSpiel.negmax(tiefe: integer; Pos: TPosition; var BesterZug: TZug): longint;
  var Wert, NachfolgerWert: longint;
      Probezug, Zug: TZug;
      Nachfolger: TPosition;
      x,y: 0..3;
  begin
    if (tiefe >= MaxSuchtiefe) or (amEnde(Pos))
    then negmax:= HeuristischerWert(Pos)
    else begin
           Wert:= -1000000;
           for x:= 0 to 3
           do for y:= 0 to 3
              do begin
                   Probezug.x:= x;
                   Probezug.y:= y;
                   if zulaessig(Pos,Probezug)
                   then begin
                          Ausfuehren(Pos, Probezug, Nachfolger);
                          NachfolgerWert:= -negmax(tiefe+1, nachfolger, Zug);
                          if (NachfolgerWert>Wert) or
                             ((NachfolgerWert=Wert) and (random(2)=0))
                          then begin
                                 Wert:= NachfolgerWert;
                                 BesterZug:= Probezug;
                               end;

                        end;
                 end;
           negmax:= Wert;
         end;
  end;

function TSpiel.Computerzug(var Wertung: longint): TZug;
var BesterZug: TZug;
    BesterWert: longint;

begin

  Wertung:= negmax(0, Position, BesterZug);

  ComputerZug:= BesterZug;
end;

end.
