unit Pmd;

interface

uses SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
     Forms, Dialogs, StdCtrls, Grids;

type
TSpielfeld = array[0..3,0..3,0..3] of shortint;

TSpieler = (spieler1,spieler2);

TSpielertyp = (Computer, Mensch);

TZug = record
        x,y: integer;
       end;

TReihensummenhaeufigkeit = array[0..20] of byte;

TPosition = record
             Feld: TSpielfeld;
             amZug: TSpieler;
            end;

TSpiel = class
           Position: TPosition;
           Spielertyp: array[1..2] of TSpielertyp;
           schwierigkeit: integer;
           constructor create(SpTyp1,SpTyp2: TSpielerTyp;var sg: integer);
           function amEnde(Position:TPosition): boolean;
           function zu_laessig(Position:Tposition; Zug:TZug): boolean;
           function Computerzug: TZug;
           function Spielerzug(e_x, E_y : Tedit):TZug ;
           procedure Spiel_starten(Felt :Tspielfeld; e_x, E_y : Tedit; SG : TStringgrid);
           procedure Ausfuehren(Position: TPosition; Zug: Tzug; var neuePos: TPosition);
           procedure Ausgabe(SG : TStringgrid);
          {private}
           function HeuristischerWert(Pos:Tposition; tiefe:integer): longint;
           function Reihensummenhaeufigkeiten(Position: TPosition): TReihensummenhaeufigkeit;
           function NegMax(Pos: TPosition; var besterZug: Tzug; tiefe : byte): longint;
           function z_von_zug(Pos:Tposition; Zug:TZug): byte;
         end;


var prg_ende: boolean;

implementation

constructor TSpiel.create(SpTyp1,SpTyp2: TSpielerTyp;var sg: integer);
begin
 prg_ende := false;
 Spielertyp[1]:= SPTyp1;
 Spielertyp[2]:= SpTyp2;
 schwierigkeit := sg;
end;

function TSpiel.Reihensummenhaeufigkeiten(Position:TPosition): TReihensummenhaeufigkeit;
var RSH: TReihensummenhaeufigkeit;
    i,j,k: integer;
    summe1,summe2,summe3: integer;
begin
 for i:= 0 to 20 do RSH[i]:= 0;
 for i:= 0 to 3 do begin
  for j:= 0 to 3 do begin
   summe1:= 0;
   summe2:= 0;
   summe3:= 0;
   for k:= 0 to 3 do begin
    summe1:= summe1 + Position.Feld[i,j,k];
    summe2:= summe2 + Position.Feld[j,k,i];
    summe3:= summe3 + Position.Feld[k,i,j]
   end;
   inc(RSH[summe1]);
   inc(RSH[summe2]);
   inc(RSH[summe3])
  end;
 end;

 for i:= 0 to 3 do begin
  j:=0;
  k:=0;
  summe1:=0;
  repeat
  summe1 := summe1 + Position.Feld[i,j,k];
  inc(j);
  inc(k);
  until j=4;
  inc(RSH[summe1]);
 end;

 for i:= 0 to 3 do begin
  j:=0;
  k:=3;
  summe1:=0;
  repeat
  summe1 := summe1 + Position.Feld[i,j,k];
  inc(j);
  dec(k);
  until j=4;
  inc(RSH[summe1]);
 end;

 for j:= 0 to 3 do begin
  i:=0;
  k:=0;
  summe1:=0;
  repeat
  summe1 := summe1 + Position.Feld[i,j,k];
  inc(i);
  inc(k);
  until i=4;
  inc(RSH[summe1]);
  end;

  for j:= 0 to 3 do begin
  i:=3;
  k:=0;
  summe1:=0;
  repeat
  summe1 := summe1 + Position.Feld[i,j,k];
  dec(i);
  inc(k);
  until i=-1;
  inc(RSH[summe1]);
  end;

 for k:= 0 to 3 do begin
  j:=0;
  i:=0;
  summe1:=0;
  repeat
  summe1 := summe1 + Position.Feld[i,j,k];
  inc(j);
  inc(i);
  until j=4;
  inc(RSH[summe1]);
  end;

  for k:= 0 to 3 do begin
  j:=3;
  i:=0;
  summe1:=0;
  repeat
  summe1 := summe1 + Position.Feld[i,j,k];
  dec(j);
  inc(i);
  until j=-1;
  inc(RSH[summe1]);
  end;

  i:=0;
  j:=0;
  k:=0;
  summe1:=0;
  repeat
  summe1:= summe1 + Position.Feld[i,j,k];
  inc(i);
  inc(j);
  inc(k);
  until k = 4;
  inc(RSH[summe1]);


  i:=3;
  j:=0;
  k:=0;
  summe1:=0;
  repeat
  summe1:= summe1 + Position.Feld[i,j,k];
  dec(i);
  inc(j);
  inc(k);
  until k = 4;
  inc(RSH[summe1]);


  i:=0;
  j:=0;
  k:=3;
  summe1:=0;
  repeat
  summe1:= summe1 + Position.Feld[i,j,k];
  inc(i);
  inc(j);
  dec(k);
  until k = -1;
  inc(RSH[summe1]);


  i:=3;
  j:=0;
  k:=3;
  summe1:=0;
  repeat
  summe1:= summe1 + Position.Feld[i,j,k];
  dec(i);
  inc(j);
  dec(k);
  until k = -1;
  inc(RSH[summe1]);



  Reihensummenhaeufigkeiten:=RSH;


end;

function TSpiel.amEnde(Position:TPosition): boolean;
var endwert : boolean;
    RSH : TReihensummenhaeufigkeit;

function ebene_voll(feld: TSpielfeld): boolean;
var x,y,z: integer;
    endwert: boolean;
begin
 endwert:= true;
 z:= 3;
 for x:= 0 to 3 do
  for y := 0 to 3 do
   if feld[x,y,z] = 0
    then endwert:= false;
 ebene_voll:= endwert
end;

begin
RSH := Reihensummenhaeufigkeiten(Position);
endwert := false;
If (RSH[4] > 0) or (RSH[20] > 0) or (Ebene_voll(Position.Feld))
   then endwert := true;
amende := (endwert) or prg_ende;
end;

function TSpiel.zu_laessig(Position:Tposition; Zug:TZug): boolean;
var endwert : boolean;
begin
endwert := true;
If (z_von_zug(Position,Zug) > 3) or (amende(Position))
   then endwert := false;
zu_laessig := endwert;
end;

function TSpiel.Computerzug: TZug;
var neuer_Zug : TZug;
begin
negmax (Position, neuer_Zug, schwierigkeit);
Computerzug := neuer_Zug;
end;

function TSpiel.Spielerzug(e_x, e_y : TEdit): TZug;
begin
 Spielerzug.x:=Strtoint(inputbox('X-Wert','Bitte',''));
 Spielerzug.y:=Strtoint(inputbox('Y-Wert','Bitte',''));
end;

procedure TSpiel.Spiel_starten(Felt : Tspielfeld; e_x, e_y : Tedit; SG : TStringgrid);
var f,d,p : integer;
    RSH : Treihensummenhaeufigkeit;
    neuPos: TPosition;
    Zug :TZug;

    begin
  Position.feld:= felt;
  Position.amzug := Spieler1;
  RSH := Reihensummenhaeufigkeiten(Position);
  Repeat
   showmessage('Zug');
   if (Position.amZug = Spieler1)
   then begin
          if SpielerTyp[1] = Computer
          then Zug := Computerzug
          else Zug := Spielerzug(e_x,e_y);
          if zu_laessig(Position,Zug)
          then ausfuehren(Position,Zug,neuPos);
          Position := neuPos;
          Ausgabe(SG);
        end
   else begin
          if SpielerTyp[2] = Computer
          then Zug := Computerzug
          else Zug := Spielerzug(e_x,e_y);
          if zu_laessig(Position,Zug)
          then ausfuehren(Position,Zug,neuPos);
          Position := neuPos;
          Ausgabe(SG);
        end
  until amEnde(Position);
end;

procedure TSpiel.Ausfuehren(Position: TPosition; Zug: Tzug; var neuePos: TPosition);
begin
 If (Position.amZug = Spieler1)
 then begin
       Position.Feld[Zug.X,Zug.Y,Z_von_Zug(Position,Zug)] := 1;
       Position.amZug:= spieler2;
      end
 else begin
       Position.Feld[Zug.X,Zug.Y,Z_von_Zug(Position,Zug)] := 5;
       Position.amZug:= spieler1;
      end;

 neuePos := Position;
end;

procedure TSpiel.Ausgabe(SG : TStringgrid);
var i,j : integer;
begin
for i := 0 to 3 do
  for j := 0 to 3 do
    begin
       SG.cells[i,j] := inttostr(Position.Feld[i,j,0]);
       SG.cells[i + 4,j] := inttostr(Position.Feld[i,j,1]);
       SG.cells[i,j + 4]  := inttostr(Position.Feld[i,j,2]);
       SG.cells[i + 4,j + 4]  := inttostr(Position.Feld[i,j,3]);
    end;
end;

function TSpiel.HeuristischerWert(Pos:Tposition; tiefe:integer): longint;
var rsh: TReihensummenhaeufigkeit;
    hw: longint;
begin
 rsh:= reihensummenhaeufigkeiten(pos);
 hw:= 0;
 if pos.amzug = spieler1
  then begin
        hw:= hw + rsh[1]*3;
        hw:= hw + rsh[2]*15;
        hw:= hw + rsh[3]*63;
        hw:= hw + rsh[4]*255;
        hw:= hw - rsh[5];
        hw:= hw - rsh[10]*7;
        hw:= hw - rsh[15]*31;
        hw:= hw - rsh[20]*127
       end
  else begin
        hw:= hw - rsh[1];
        hw:= hw - rsh[2]*7;
        hw:= hw - rsh[3]*31;
        hw:= hw - rsh[4]*127;
        hw:= hw + rsh[5]*3;
        hw:= hw + rsh[10]*15;
        hw:= hw + rsh[15]*63;
        hw:= hw + rsh[20]*255
       end;

 heuristischerwert:= hw

end;

function TSpiel.NegMax(Pos: TPosition; var besterZug: Tzug; tiefe : byte): longint;
var wertung, Probezug : longint;
    Zoch, Dummy : Tzug;
    Nachfolgeposition : TPosition;
    i,j : integer;
begin
 if (amEnde(Pos)) or (tiefe = 4)
  then wertung:= heuristischerwert(pos,3)
  else begin
       wertung := -1000000;
       for i:= 0 to 3
          do for j := 0 to 3
            do begin
               Zoch.x := i;
               Zoch.y := j;
            if zu_laessig(Pos,Zoch)
              then begin
                    ausfuehren(Pos,Zoch,Nachfolgeposition);
                    Probezug := -negmax(Nachfolgeposition, Dummy, tiefe + 1);
                    if Probezug > Wertung
                     then begin
                           Besterzug:= Zoch;
                           Wertung:=Probezug
                          end
                   end
            end
       end;
Negmax := wertung;
end;

function TSpiel.z_von_zug(Pos:Tposition; Zug:TZug): byte;
var z : byte;
begin
z := 0;
while Pos.Feld[Zug.x, Zug.y, z] <> 0
      do inc(z);
z_von_zug := z;
end;


end.
