unit Uf_4g3d;

(******************************************************************************)
(***                                                                        ***)
(***  Uf_4g3d (03/04 2003) Design-Gruppe (ABI 2003 Informatik LK Ga)        ***)
(***  E. Breuer, B. Bunse, T. Thien, M. Tnissen, N. Winnen                 ***)
(***                                                                        ***)
(***  Aufgabenfelder und Besetzung:                                         ***)
(***  3D-Darstellung incl. Form: "DIE ZWEI"                                 ***)
(***  Zusammenkunft KI & Grafik: "DIE ZWEI"                                 ***)
(***  Form fr Setup, Info & Help: "DIE MDELS"                             ***)
(***  Einbindung der o. g. Formen von "DIE MDELS": "DIE ZWEI"              ***)
(***  Kommentare: "CHIEF"                                                   ***)
(***  Credits: "DIE ZWEI"                                                   ***)
(***  nix/kaum was: "DER REST"                                              ***)
(***                                                                        ***)
(***                                                last updated: 02/04/03  ***)
(**********************************  2003 by Informatik LK (Ga) ABI 2003 *****)


interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls, Spin, Menus, u_info, u_regeln, pmd, interakt, u_eing;

const fg_farbe = $745c34;
      bg_farbe = $AADAFF;

type
(*  TMatrix = array[0..2,0..2] of string; *)
  TMarke = record
            gesetzt: boolean;
            color: TColor;
            x,y,z: integer;
           end;
  TStab = record
           kreis: TImage;
           x,y,z: real;
           x_o,y_o,z_o: real;
           y_r: real;
           color: TColor;
           Marken: array[0..3] of TMarke;
          end;
  TGelberzug = record
               x,y,z: shortint;
               end;
  TStaebe = array[0..3,0..3] of TStab;
  TF_4g3d = class(TForm)
    ti_create: TTimer;
    img_neu: TImage;
    img_end: TImage;
    mm_1: TMainMenu;
    M_Datei: TMenuItem;
    M_neu: TMenuItem;
    m_laden: TMenuItem;
    m_speichern: TMenuItem;
    M_beenden: TMenuItem;
    m_hilfe: TMenuItem;
    m_anleitung: TMenuItem;
    m_info: TMenuItem;
    img_kreis: TImage;
    M_Optionen: TMenuItem;
    img_info: TImage;
    img_help: TImage;
    Option11: TMenuItem;
    Image1: TImage;
    procedure aktualisiere_grafik;
    procedure FormCreate(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ti_createTimer(Sender: TObject);
    procedure img_endClick(Sender: TObject);
    procedure m_anleitungClick(Sender: TObject);
    procedure m_infoClick(Sender: TObject);
    procedure M_beendenClick(Sender: TObject);
    procedure img_kreisMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure img_kreisMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure aktualisiere_staebe(position: TPosition);
    procedure Spielerzug;
    procedure M_neuClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure img_helpClick(Sender: TObject);
    procedure img_infoClick(Sender: TObject);
    procedure Image1Click(Sender: TObject);
  private
    { Private declarations }
    Staebe: TStaebe;
    procedure drehen(x,y,z: real);
    procedure setze_zug(x,y: integer);
  public
    { Public declarations }
  end;

var
  F_4g3d: TF_4g3d;
  x_mouse,y_mouse: integer;
  Spiel: TSpiel;
  global_zug: TZug;
  letzter_zug: TGelberZug;
  ende: boolean;
  s1, s2: TSpielerSetup;

implementation

{$R *.DFM}


{ >>> F_3d4g PROZEDUREN >>> }

(* zeichnet die komplette Grafik neu:  untere Flche, Stbe, Marken *)
procedure TF_4g3d.aktualisiere_grafik;
var m,x,y,i: shortint;                                   (* Durchlaufsvariablen *)
begin
F_4g3d.refresh;
if Staebe[0,0].y < Staebe[0,0].y_o
   then for x := 0 to 3 do for y := 0 to 3 do Staebe[x,y].y_r := Staebe[x,y].y+abs(round((Staebe[x,y].y_o - Staebe[x,y].y)))
   else for x := 0 to 3 do for y := 0 to 3 do Staebe[x,y].y_r := Staebe[x,y].y_o;
(* untere Flche (Spielbrett) zeichnen *)
F_4g3d.canvas.polygon([point(round(Staebe[0,0].x+400),(round(Staebe[0,0].y)+300)),
                       point(round(Staebe[0,3].x+400),(round(Staebe[0,3].y)+300)),
                       point(round(Staebe[3,3].x+400),(round(Staebe[3,3].y)+300)),
                       point(round(Staebe[3,0].x+400),(round(Staebe[3,0].y)+300))]);
for x := 0 to 3 do
    for y := 0 to 3 do
        begin
        (* Kreise malen *)
        Staebe[x,y].kreis.left := round(Staebe[x,y].x_o) - 11 + 400;
        Staebe[x,y].kreis.top := round(Staebe[x,y].y_o) - 11 + 300;
        (* Position der Stbe verwerten und umwandeln in Koordinaten *)
        if Staebe[x,y].y < Staebe[x,y].y_o
           then Staebe[x,y].y_r := round(Staebe[x,y].y) + 300
           else Staebe[x,y].y_r := round(Staebe[x,y].y_o) + 300;
        (* Stbe per LineTo zeichnen *)
        if Staebe[x,y].y > Staebe[x,y].y_o
           then begin
                F_4g3d.canvas.moveto((round(Staebe[x,y].x_o) + 400),(round(Staebe[x,y].y_o) + 300));
                F_4g3d.canvas.lineto((round(Staebe[x,y].x) + 400),(round(Staebe[x,y].y) + 300));
                end
           else begin
                F_4g3d.canvas.moveto((round(Staebe[x,y].x) + 400),(round(Staebe[x,y].y) + 300));
                F_4g3d.canvas.lineto((round(Staebe[x,y].x_o) + 400),(round(Staebe[x,y].y_o) + 300));
                end;
        (* Marken zeichnen *)
        for m := 0 to 3 do
            if (Staebe[x,y].Marken[m].gesetzt)
               then begin
                    F_4g3d.canvas.brush.color := Staebe[x,y].Marken[m].color;
                    F_4g3d.canvas.ellipse(((Staebe[x,y].Marken[m].x) + 400),
                                          ((Staebe[x,y].Marken[m].y) + 300),
                                          ((Staebe[x,y].Marken[m].x) + 400+25),
                                          ((Staebe[x,y].Marken[m].y) + 300)+25);
                    F_4g3d.canvas.brush.color := clwhite;
                    end;
        end;
end;

(* yaw (x), pitch (y), roll(z) - hierzu die Matrix vom Blatt *)
procedure TF_4g3d.drehen(x,y,z: real);
var i,j,m: integer;                                      (* Durchlaufsvariablen *)
    h: array[0..3, 0..2] of real;           (* speichert die Zwischenergebnisse *)
begin
for i := 0 to 3 do
    for j := 0 to 3 do
        begin
        (* neue Koordinaten des unteren Punktes der Stbe *)
        h[0,0] := (cos(y)*cos(z))*(Staebe[i,j].x);
        h[0,1] := (-(cos(x)*sin(z))-(sin(x)*sin(y)*cos(z)))*(Staebe[i,j].y);
        h[0,2] := ((sin(x)*sin(z))-(cos(x)*sin(y)*cos(z)))*(Staebe[i,j].z);
        h[1,0] := (cos(y)*sin(z))*(Staebe[i,j].x);
        h[1,1] := ((cos(x)*cos(z))-(sin(x)*sin(y)*sin(z)))*(Staebe[i,j].y);
        h[1,2] := (-(cos(x)*sin(y)*sin(z))-(sin(x)*cos(z)))*(Staebe[i,j].z);
        h[2,0] := (sin(y))*(Staebe[i,j].x);
        h[2,1] := (sin(x)*cos(y))*(Staebe[i,j].y);
        h[2,2] := (cos(x)*cos(y))*(Staebe[i,j].z);
        Staebe[i,j].x := h[0,0] + h[0,1] + h[0,2];
        Staebe[i,j].y := h[1,0] + h[1,1] + h[1,2];
        Staebe[i,j].z := h[2,0] + h[2,1] + h[2,2];
        (* neue Koordinaten des oberen Punktes der Stbe *)
        h[0,0] := (cos(y)*cos(z))*(Staebe[i,j].x_o);
        h[0,1] := (-(cos(x)*sin(z))-(sin(x)*sin(y)*cos(z)))*(Staebe[i,j].y_o);
        h[0,2] := ((sin(x)*sin(z))-(cos(x)*sin(y)*cos(z)))*(Staebe[i,j].z_o);
        h[1,0] := (cos(y)*sin(z))*(Staebe[i,j].x_o);
        h[1,1] := ((cos(x)*cos(z))-(sin(x)*sin(y)*sin(z)))*(Staebe[i,j].y_o);
        h[1,2] := (-(cos(x)*sin(y)*sin(z))-(sin(x)*cos(z)))*(Staebe[i,j].z_o);
        h[2,0] := (sin(y))*(Staebe[i,j].x_o);
        h[2,1] := (sin(x)*cos(y))*(Staebe[i,j].y_o);
        h[2,2] := (cos(x)*cos(y))*(Staebe[i,j].z_o);
        Staebe[i,j].x_o := h[0,0] + h[0,1] + h[0,2];
        Staebe[i,j].y_o := h[1,0] + h[1,1] + h[1,2];
        Staebe[i,j].z_o := h[2,0] + h[2,1] + h[2,2];
        (* neue Koordinaten der Marken *)
        for m := 0 to 3 do
            begin
            Staebe[i,j].Marken[m].x := round(Staebe[i,j].x + (m*(Staebe[i,j].x_o-Staebe[i,j].x))/4)-11;
            Staebe[i,j].Marken[m].y := round((Staebe[i,j].y) + (m*(Staebe[i,j].y_o-Staebe[i,j].y))/4-11);
            Staebe[i,j].Marken[m].z := round(Staebe[i,j].z) - 11;
            end;
        end;
aktualisiere_grafik;
end;

(* Vorinitialisierung - Stbe erstellen und initialisieren *)
procedure TF_4g3d.FormCreate(Sender: TObject);
var i,x,y: integer;                                      (* Durchlaufsvariablen *)
begin
ende := false;
(* Initialisierung des Spiels => KI-Gruppe *)
init_interaktion;
for y := 0 to 3 do
    for x := 0 to 3 do
        begin
        (* Markenanzahl auf jedem Stab zu Beginn = 0! *)
        for i := 0 to 3 do Staebe[x,y].Marken[i].gesetzt := false;
        Staebe[x,y].color := fg_farbe;
        (* Initialisierung der Positionen der Stbe *)
        Staebe[x,y].x := (x - 1.5)*100;
        Staebe[x,y].y := 0;
        Staebe[x,y].z := y*100;
        Staebe[x,y].x_o := Staebe[x,y].x;
        Staebe[x,y].y_o := Staebe[x,y].y-100;
        Staebe[x,y].z_o := Staebe[x,y].z;
        (* Kreis-Buttons ber die Stbe setzen und Eigenschaften bestimmen *)
        Staebe[x,y].kreis := TImage.create(F_4g3d);
        Staebe[x,y].kreis.parent := F_4g3d;
        Staebe[x,y].kreis.width := 25;
        Staebe[x,y].kreis.height := 25;
        Staebe[x,y].kreis.OnMouseMove := img_kreisMouseMove;
        Staebe[x,y].kreis.OnMouseDown := img_kreisMouseDown;
        Staebe[x,y].kreis.cursor := crCross;
        end;
(* erste Drehung fr benutzerfreundlichere Startposition *)
drehen(-0.5,0.5,0.5);
F_4g3d.canvas.refresh;
F_4g3d.canvas.pen.color := fg_farbe;
ti_create.enabled := true;
end;

(* Mouse-Over-Effekt beenden, wenn Maus ber Form bewegt *)
procedure TF_4g3d.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var i,j: integer;                                        (* Durchlaufsvariablen *)
    x_div,y_div,z_div: integer;               (* Mauskoordinaten vorher-nachher *)
begin
(* ursprngliches Bild fr die Kreis-Buttons einfgen *)
for i := 0 to 3 do
    for j := 0 to 3 do Staebe[i,j].kreis.Picture.loadfromfile('Kreis1.bmp');
(* besonderer Button fr den Stab mit der letztgesetzten Marke *)
Staebe[letzter_zug.x,letzter_zug.y].kreis.Picture.loadfromfile('Kreis1_2.bmp');
(* Maus-Koordinaten auswerten fr evtl. Bewegung des Spielfeldes *)
x_div := x - x_mouse;
y_div := y - y_mouse;
x_mouse := x;
y_mouse := y;
(* drehen des Feldes, falls Maustaste gedrckt *)
if (ssLeft in Shift)
   then begin
        drehen(-(y_div/100),0,0);
        if (ssShift in Shift)
           then drehen(0,0,-(x_div/100))
           else drehen(0,-(x_div/100),0);
        end;
end;

(* erstes Mal Linien auf der Form zeichnen *)
procedure TF_4g3d.ti_createTimer(Sender: TObject);
begin
(* Timer, da Linien bei F_4g3d.create nicht gezeichnet werden
 - ein Fehler von vielen in Delphi 1.0! *)
if ende then F_ein.show
        else aktualisiere_grafik;
ti_create.enabled := false;
end;

(* Beenden-Button per Image *)
procedure TF_4g3d.img_endClick(Sender: TObject);
begin
(* eindeutig? *)
close;
end;

(* Men: Info (Version etc) *)
procedure TF_4g3d.m_infoClick(Sender: TObject);
begin
F_info.show;
end;

(* Men: Beenden *)
procedure TF_4g3d.M_beendenClick(Sender: TObject);
begin
close;
end;

(* Men: Anleitung *)
procedure TF_4g3d.m_anleitungClick(Sender: TObject);
begin
F_hilfe.show;
end;

(* whrend dem Spiel nicht sichtbares Image, aber Grundlage fr die sichtbaren Kreis-buttons *)
procedure TF_4g3d.img_kreisMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var i,j: integer;                                        (* Durchlaufsvariablen *)
begin
for i := 0 to 3 do
    for j := 0 to 3 do
        if Sender = Staebe[i,j].kreis
           then begin
                global_zug.x := i;
                global_zug.y := j;
                end;
mach_weiter;
end;

(* s. TF_4g3d.img_kreisMouseDown *)
procedure TF_4g3d.img_kreisMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var i,j: integer;                                        (* Durchlaufsvariablen *)
begin
for i := 0 to 3 do
    for j := 0 to 3 do
        if Sender = Staebe[i,j].kreis
           then if (i = letzter_zug.x) and (j = letzter_zug.y)
                   then Staebe[letzter_zug.x,letzter_zug.y].kreis.Picture.loadfromfile('Kreis2_2.bmp')
                   else Staebe[i,j].kreis.Picture.loadfromfile('Kreis2.bmp');
(*Staebe[letzter_zug.x,letzter_zug.y].kreis.Picture.loadfromfile('Kreis2_2.bmp')*);
end;

                                                                                
procedure TF_4g3d.aktualisiere_staebe(position: TPosition);
var x,y,z: shortint;                                     (* Durchlaufsvariablen *)
begin
{ Umwandlung der zurckgegebenen Position zum Stabfeld }
for x := 0 to 3 do
    for y := 0 to 3 do
        for z := 0 to 3 do
            begin
             if position.feld[x,y,z] = 1
                then begin
                     case s1.color of
                      0: staebe[x,y].marken[z].color := clred;
                      1: staebe[x,y].marken[z].color := clblue;
                      2: staebe[x,y].marken[z].color := cllime;
                      3: staebe[x,y].marken[z].color := clyellow;
                      4: staebe[x,y].marken[z].color := clpurple;
                     end;
                      staebe[x,y].marken[z].gesetzt := true;
                     end
                else if position.feld[x,y,z] = 5
                        then begin
                             case s2.color of
                              0: staebe[x,y].marken[z].color := clred;
                              1: staebe[x,y].marken[z].color := clblue;
                              2: staebe[x,y].marken[z].color := cllime;
                              3: staebe[x,y].marken[z].color := clyellow;
                              4: staebe[x,y].marken[z].color := clpurple;
                             end;
                             staebe[x,y].marken[z].gesetzt := true;
                             if staebe[x,y].marken[3].gesetzt then staebe[x,y].kreis.enabled := false;
                             end
                        else staebe[x,y].marken[z].gesetzt := false;
             end;
end;

(* wartet, bis der Spieler die nchste Marke setzt *)
procedure TF_4g3d.Spielerzug;
begin
(* thx @ interakt.pas ^^ *)
warte;
end;

(* NEED MORE COMMENTS!!!!! *)  (* NEED MORE COMMENTS!!!!! *)  (* NEED MORE COMMENTS!!!!! *)  (* NEED MORE COMMENTS!!!!! *)
(* "besonderes" Kreis-Button ber den Stab mit der zuletzt gesetzten Marke *)
procedure TF_4g3d.setze_zug(x,y: integer);
var i,j: integer;                                        (* Durchlaufsvariablen *)
begin
letzter_zug.x := x;
letzter_zug.y := y;
i := 0;
if i = 3 then staebe[x,y].kreis.enabled := false;
for i := 0 to 3 do
    for j := 0 to 3 do Staebe[i,j].kreis.Picture.loadfromfile('Kreis1.bmp');
Staebe[letzter_zug.x,letzter_zug.y].kreis.Picture.loadfromfile('Kreis1_2.bmp');
end;

(* Initialisierung des Spiels *)
procedure TF_4g3d.M_neuClick(Sender: TObject);
var f: file of TSetup;
    schwierigkeit: integer;
    Zug: TZug;
    np: TPosition;
    spieler: string;
begin
(* Einstellungen laden *)
if not fileexists('3d4g.ini')
   then begin
        messagedlg('Bitte Setup ausfhren!', mtwarning, [mbok], 0);
        ende := true;
        end;
if fileexists('3d4g.ini')
   then begin
        assignfile(f,'3d4g.ini');
        FileMode := 0;
        reset(f);
        read(f,setup);
        s1 := setup.setup1;
        s2 := setup.setup2;
        schwierigkeit := setup.sg;
        closefile(f);
        end
   else messagedlg('Fehler beim Setup! Standardwerte werden benutzt', mtwarning, [mbok], 0);
Spiel := TSpiel.create(s1.typ,s2.typ,schwierigkeit);
aktualisiere_staebe(Spiel.position);
aktualisiere_grafik;
while not Spiel.amEnde(Spiel.Position)
   do begin
       if Spiel.Position.amZug = Spieler1
          then if Spiel.Spielertyp[1] = Computer
                  then Zug := Spiel.Computerzug
                  else begin
                       Spielerzug;
                       Zug := global_zug;
                       end
          else if Spiel.Spielertyp[2] = Computer
                  then Zug := Spiel.Computerzug
                  else begin
                       Spielerzug;
                       Zug := global_zug;
                       end;
       Spiel.ausfuehren(Spiel.Position,Zug,np);
       Spiel.position := np;
       setze_zug(Zug.x,Zug.y);
       aktualisiere_staebe(np); { Schnittstelle KI <-> Grafik / Die Rckgabe der KI (np: TPosition)  }
       aktualisiere_grafik;     { wird auf Staebe: array[..] of TStab compiliert und ausgegeben     }
      end;
if Spiel.Position.amZug = spieler1
   then spieler := s2.name
   else spieler := s1.name;
messagedlg('Yippieh!!! ' + spieler + ' hat gewonnen!!!', mtinformation, [mbok], 0)
end;

procedure TF_4g3d.FormClose(Sender: TObject; var Action: TCloseAction);
begin
prg_ende := true;
hoer_auf;
end;

procedure TF_4g3d.img_helpClick(Sender: TObject);
begin
F_hilfe.show;
end;

procedure TF_4g3d.img_infoClick(Sender: TObject);
begin
F_Info.show;
end;

procedure TF_4g3d.Image1Click(Sender: TObject);
begin
F_ein.show;
end;

(******************************************************************************)
(***                                                                        ***)
(***  VIEL SPASS BEIM SPIELEN!! Und hey...! Nix klauen! ;o)                 ***)
(***   MfG Marc Tnissen                                                    ***)
(***                                                                        ***)
(******************************************************************************)

end.

